' euc2sjis.VBS V1.05 (C) yoshioka.teruo@nifty.com 2006-04-06
' euc2sjis.VBS converts character code from EUC to Shift JIS
' Usage: Start euc2sjis.vbs files...
' Usage: CScript.exe //NoLogo euc2sjis.vbs [<input] [>output]

Option Explicit

Dim Lines()
Dim LineCount
Dim Page

Dim Odd

WScript.Quit Main()

Function Main()
Dim fso
Dim Path
Dim StdIn
Dim StdOut
Dim oPath
Dim BaseName
Dim n
Dim File
Dim tName
Dim FileName
Dim tPath
Dim wShell
Const vbHide=0
Dim Command
Dim rc

Set wShell=CreateObject("WScript.Shell")
Set fso=CreateObject("Scripting.FileSystemObject")

For Each Path In WScript.Arguments
  Path=fso.GetAbsolutePathName(Path)
  Set File=fso.GetFile(Path)
  tPath=fso.BuildPath(fso.GetSpecialFolder(2).Path,fso.GetTempName())
  Set StdIn=fso.CreateTextFile(tPath)
  Odd=CBool(File.Size Mod 2)
  If Odd Then
    StdIn.Write Chr(&HFF) & Chr(&HFE) & Chr(0)
  Else
    StdIn.Write Chr(&HFF) & Chr(&HFE)
  End If
  StdIn.Close
  Command="%COMSPEC% /CCOPY /B """ & tPath & """+""" & File.PATH & """ """ &  tPath & """"
'  rc=wShell.Run(Command,1,True)
  rc=wShell.Run(Command,vbHide,True)
'  WScript.Echo rc,command
  Set StdIn=fso.OpenTextFile(tPath,,,True)
  BaseName=fso.GetBaseName(Path)
  FileName=fso.GetFileName(Path)
  oPath=fso.BuildPath(fso.GetParentFolderName(Path),fso.GetTempName())
  Set StdOut=fso.CreateTextFile(oPath)
  Call euc2sjis(StdIn,StdOut)
  StdIn.Close
  StdOut.Close
  fso.DeleteFile(tPath)

  For n=1000 To 1999
    tName=BaseName & "." & Right(n,3)
    Call Rename(File,tName)
    If Err=0 Then
      Exit For
    ElseIf Err<>58 Then
      WScript.Echo Err.Number & " : " & Err.Description
      WScript.Quit
    End If
  Next
  WScript.Echo FileName & " -> " & tName

  Set File=fso.GetFile(oPath)
  Call Rename(File,FileName)
  If Err<>0  Then
    WScript.Echo Err.Number & ":" & Err.Description
    WScript.Quit
  End If
Next
If WScript.Arguments.Count=0 Then
  If LCase(fso.GetBaseName(WScript.FullName))="cscript" Then
    Call euc2sjis(fso.GetStandardStream(0,True),WScript.StdOut)
  Else
    WScript.Echo "Usage: start euc2sjis.vbs files..."
    WScript.Quit
  End If
End If
End Function

Sub Rename(File,Name)
On Error Resume Next
File.Name=Name
End Sub

Sub euc2sjis(StdIn,StdOut)
Dim code
Dim code1
Dim code2
Dim k,buf

If StdIn.AtEndOfStream Then Exit Sub
buf=ReadAll(StdIn)
For k=1-Odd To LenB(buf)
  code=AscB(MidB(buf,k,1))
  If code<&H80 Then
    StdOut.Write Chr(code)
  ElseIf code=&H8E Then
    k=k+1
    code=AscB(MidB(buf,k,1))
    StdOut.Write Chr(code)
  Else
    code1=code
    k=k+1
    code2=AscB(MidB(buf,k,1))
    code=jis2sjis((code1 And &H7F) * 256 + (code2 And &H7F))
    If code Then
      StdOut.Write Chr(code)
    Else
      StdOut.Write "%" & Right(Hex(code1+256),2) & "%" & Right(Hex(code2+256),2)
      Echo "Invalid EUC code : " & Right(Hex(code1+256),2) & Right(Hex(code2+256),2)
    End If
  End If
Next
EchoUp
End Sub

Function jis2sjis(j)
Dim s
Dim a
Dim b

a=j \ 256
b=j mod 256
If 33<=a And a<= 94 Then
  If a mod 2 Then
    If 33<=b And b<= 95 Then
      s=a*128+b+28831
    ElseIf 96<=b And b<=126 Then
      s=a*128+b+28832
    Else
      s=0
    End if
  Else
    If 33<=b And b<=126 Then
      s=a*128+b+28798
    Else
      s=0
    End If
  End If
ElseIf 95<=a And a<=126 Then
  If a mod 2 Then
    If 33<=b And b<= 95 Then
      s=a*128+b+45215
    ElseIf 96<=b And b<=126 Then
      s=a*128+b+45216
    Else
      s=0
    End If
  ElseIf 33<=b And b<=126 Then
    s=a*128+b+45182
  Else
    s=0
  End If
Else
  s=0
End If
If s=0 Then
  Echo "Invalid JIS Code : " & Right(Hex(a+256),2) & Right(Hex(b+256),2)
End If
jis2sjis=s
End Function

Sub EchoUp()
If LineCount>0 Then
  If vbCancel=MsgBox(Join(Lines,vbLf),vbOkCancel,"page " & Page+1) Then WScript.Quit
  LineCount=0
  Page=Page+1
End If
End Sub

Sub Echo(Line)
Const MaxLineCount=20
On Error Resume Next
WScript.StdOut.WriteLine Line
If Err=0 Then Exit Sub
If LineCount=MaxLineCount Then
  If vbCancel=MsgBox(Join(Lines,vbLf),vbOkCancel,"page " & Page+1) Then WScript.Quit
  LineCount=0
  Page=Page+1
End If
ReDim Preserve Lines(LineCount)
Lines(LineCount)=Line
LineCount=LineCount+1
End Sub

Function ReadAll(File)
Dim Block
Do While Not File.AtEndOfStream
Block=Block & File.Read(4096)
Loop
ReadAll=Block
End Function
