' sjis2euc.VBS V1.05 (C) yoshioka.teruo@nifty.com 2006-04-06
' sjis2euc.VBS converts character code from Shift JIS to EUC.
' Usage: Start sjis2euc.vbs files...
' Usage: CScript.exe //NoLogo sjis2euc.vbs [<input] [>output]

Option Explicit

Dim Lines()
Dim LineCount
Dim Page

WScript.Quit Main()

Function Main()
Dim fso
Dim Path
Dim StdIn
Dim StdOut
Dim oPath
Dim BaseName
Dim n
Dim File
Dim tName
Dim FileName
Dim wShell
Const vbHide=0
Dim Command
Dim rc

Set wShell=CreateObject("WScript.Shell")
Set fso=CreateObject("Scripting.FileSystemObject")

For Each Path In WScript.Arguments
  Path=fso.GetAbsolutePathName(Path)
  Set File=fso.GetFile(Path)
  Set StdIn=fso.OpenTextFile(Path)
  BaseName=fso.GetBaseName(Path)
  FileName=fso.GetFileName(Path)
  oPath=fso.BuildPath(fso.GetParentFolderName(Path),fso.GetTempName())
  Set StdOut=fso.CreateTextFile(oPath)
  StdOut.Write vbCrLf
  StdOut.Close
  Set StdOut=fso.OpenTextFile(oPath,8,False,True)
  Call sjis2euc(StdIn,StdOut)
  StdIn.Close
  StdOut.Close

  For n=1000 To 1999
    tName=BaseName & "." & Right(n,3)
    Call Rename(File,tName)
    If Err=0 Then
      Exit For
    ElseIf Err<>58 Then
      WScript.Echo Err.Number & " : " & Err.Description
      WScript.Quit
    End If
  Next
  WScript.Echo FileName & " -> " & tName

  Set File=fso.GetFile(oPath)
  Call Rename(File,FileName)
  If Err<>0  Then
    WScript.Echo Err.Number & ":" & Err.Description
    WScript.Quit
  End If
Next
If WScript.Arguments.Count=0 Then
  If LCase(fso.GetBaseName(WScript.FullName))="cscript" Then
    Call sjis2euc(WScript.StdIn,fso.GetStandardStream(1,True))
  Else
    WScript.Echo "Usage: start sjis2euc.vbs files..."
    WScript.Quit
  End If
End If
End Function

Sub Rename(File,Name)
On Error Resume Next
File.Name=Name
End Sub

Sub sjis2euc(StdIn,StdOut)
Dim char
Dim char2
Dim code
Dim code1
Dim n

Do While Not StdIn.AtEndOfStream
  char=StdIn.Read(1)
  code=Asc(char)
  If code<0 Then
    code=sjis2jis(code)
    If code then
      code=code Or &H8080 + 256*256
      If n=0 Then
        StdOut.Write ChrW((code Mod 256)*256+(code \ 256))
      Else
        StdOut.Write ChrW((code \ 256)*256+code1)
        code1=code Mod 256
        n=1
      End If
    Else
      StdOut.Write Escape(char)
      Echo "Invalid SJIS code : " & Escape(char)
    End If
  ElseIf code<128 Then
    If n=0 Then
      code1=code
      n=1
    Else
      StdOut.Write ChrW(code*256+code1)
      n=0
    End If
  ElseIf &HA0<code And code<&HE0 Then
    If n=0 Then
      StdOut.Write ChrW(code*256+&H8E)
    Else
      StdOut.Write ChrW(&H8E*256+code1)
      code1=code
    End If
  Else
    Echo "Invalid SJIS 1st byte : " & Right(Hex(code+256),2)
  End If
Loop
If n=1 Then
  StdOut.Write ChrW(10 * 256 + code1)
  n=0
End If
EchoUp
End Sub

Function sjis2jis(s)
Dim j
Dim a
Dim b

If s<0 Then
  s=256*256+s
End If
a=s \ 256
b=s mod 256
If 129<=a And a<=159 Then
  If 64<=b And b<=126 Then
    j=a*512+b-57631
  ElseIf 128<=b And b<=158 Then
    j=a*512+b-57632
  ElseIf 159<=b And b<=252 Then
    j=a*512+b-57470
  Else
    j=0
  End If
ElseIf 224<=a And a<=239 Then
  If 64<=b And b<=126 Then
    j=a*512+b-90399
  ElseIf 128<=b And b<=158 Then
    j=a*512+b-90400
  ElseIf 159<=b And b<=252 Then
    j=a*512+b-90238
  Else
    j=0
  End If
Else
  j=0
End If
If s=0 Then
  Echo "Invalid Shift JIS Code : " & Right(Hex(a+256),2) & Right(Hex(b+256),2)
End If
sjis2jis=j
End Function

Sub EchoUp()
If LineCount>0 Then
  If vbCancel=MsgBox(Join(Lines,vbLf),vbOkCancel,"page " & Page+1) Then WScript.Quit
  LineCount=0
  Page=Page+1
End If
End Sub

Sub Echo(Line)
Const MaxLineCount=20
On Error Resume Next
WScript.StdOut.WriteLine Line
If Err=0 Then Exit Sub
If LineCount=MaxLineCount Then
  If vbCancel=MsgBox(Join(Lines,vbLf),vbOkCancel,"page " & Page+1) Then WScript.Quit
  LineCount=0
  Page=Page+1
End If
ReDim Preserve Lines(LineCount)
Lines(LineCount)=Line
LineCount=LineCount+1
End Sub
